*-----------------------------------------------------------------------
*-- Program.....: ini.prg
*-- Programmer..: Bowen Moursund (CIS: 72662,436), Copyright 1995
*-- Date........: 12/01/1995
*-- Notes.......: Adapted and enhanced from Keith Chuvala's article
*--               in dBASE Advisor.
*-- Written for.: Visual dBASE v5.5
*-- Usage.......: Sorry, the documentation of this class is incomplete.
*--               The unelaborated usage:
*--
*--                    - Instantiate an INI object, passing the name
*--                      of the INI file as a parameter
*--                    - Call GetValue() to retrieve an INI entry
*--                    - Call SetValue() to set an INI entry
*--                    - Call GetSection() to load an entired section
*--                      into an array
*--
*--               See the code for details.
*-----------------------------------------------------------------------

CLASS INI(cIniFile)

  #define RETSIZE 320
  #define SECTION_RETSIZE 32000
  #define NULL 0
  this.Section = ""
  this.Entry = ""
  this.Inifile = ""
  this.Value = ""
  this.Default = ""
  this.SectionArray = new array()
  this.SectionArray.add("")
  this.EntriesArray = new array()
  this.EntriesArray.add("")
  this.ValuesArray = new array()
  this.ValuesArray.add("")
  class::SetIniFile(cIniFile)
  if type("GetPrivateProfileString") <> "FP"
      extern CINT GetPrivateProfileString( CSTRING,;
                                           CSTRING,;
                                           CSTRING,;
                                           CPTR,;
                                           CINT,;
                                           CSTRING ) KRNL386.EXE
  endif
  if type("WritePrivateProfileString") <> "FP"
      extern CINT WritePrivateProfileString( CSTRING,;
                                             CSTRING,;
                                             CSTRING,;
                                             CSTRING ) KRNL386.EXE
  endif

  PROCEDURE GetValue
  parameter cSection, cEntry
  this.value = space(RETSIZE)
  if type("cSection") == "C" .and. type("cEntry") == "C"
      this.Section = cSection
      this.Entry = cEntry
      GetPrivateprofileString(this.Section, this.Entry, this.Default,;
                              this.Value, RETSIZE, this.IniFile)
      this.Value = trim(this.Value)
      if right(this.Value,1) = chr(0)
          this.Value = left(this.value, len(this.value)-1)
      endif
  endif
  RETURN trim(this.Value)

  PROCEDURE SetValue
  parameter cSection, cEntry, cNewValue
  local nBytes
  if type("cSection") == "C" .and. type("cEntry") == "C" .and.;
     type("cNewValue") == "C"
      this.Section = cSection
      this.Entry = cEntry
      this.Value = ltrim(trim(cNewValue))
      nBytes = WritePrivateProfileString(this.Section, this.Entry,;
                                         this.Value, this.IniFile)
  else
      nBytes = 0
  endif
  RETURN nBytes

  PROCEDURE SetIniFile
  parameter cIniFile
  local p
  if type("cIniFile") <> "C"
      this.IniFile = set("directory") + "\" + program()
  else
      this.IniFile = cIniFile
  endif
  this.IniFile = ltrim(trim(this.IniFile))
  if (at("\", this.IniFile) = 0)  && if no path specified
      this.IniFile = set("directory") + "\" + this.IniFile  && current directory
  endif
  if right(upper(this.IniFile),4) <> ".INI"
      p = at(".", this.IniFile)
      if p > 0
          this.IniFile = stuff(this.IniFile, p, 4, ".INI")
      else
          this.IniFile = this.IniFile + ".INI"
      endif
  endif


  PROCEDURE GetSection
  *-- Returns reference to array containing all entries for the
  *-- specified section
  parameter cSection
  this.SectionArray = new array()
  if type("cSection") == "C"
      this.Section = cSection
      local nBytes, cBuffer
      cBuffer = space(SECTION_RETSIZE)
      nBytes = GetPrivateProfileString(cSection, NULL, this.Default,;
                                       cBuffer, SECTION_RETSIZE,;
                                       this.IniFile )
      if nBytes = 0
          this.SectionArray.add("")
      else
          local cValueBuffer, nPosition, cValue, cEntry
          cValueBuffer = space(RETSIZE)
          nPosition = 1
          do while nPosition < nBytes
              cEntry = substr(cBuffer, nPosition)
              cEntry = left(cEntry, at(chr(0), cEntry) - 1)
              nPosition = nPosition + len(cEntry) + 1
              GetPrivateProfileString(cSection, cEntry, ;
                                      cEntry + " not found",;
                                      cValueBuffer, RETSIZE,;
                                      this.IniFile)
              cValue = left(cValueBuffer, at(chr(0), cValueBuffer) - 1)
              this.SectionArray.add(cEntry + "=" + cValue)
          enddo
      endif
  else
      this.SectionArray.add("")
  endif
  RETURN this.SectionArray

  PROCEDURE SectionArrayParse2Arrays
  parameters cDelimiter
  local aArrays, aEntries, aValues, nRows, nCols, n, cString, nLen,;
        nPosition, nCol, cSubStr
  aArrays = new array()
  this.EntriesArray = new array()
  nRows= alen(this.SectionArray,1)
  nCols = 1
  for n = 1 to nRows
      this.EntriesArray.add(left(this.SectionArray[n],at("=",this.SectionArray[n])-1))
      if type("cDelimiter") = "C"
          nCols = max(nCols, class::CharCount(cDelimiter, this.SectionArray[n]) + 1)
      endif
  endfor
  aArrays.add(this.EntriesArray)
  this.ValuesArray = new array(nRows, nCols)
  for n = 1 to nRows
      cString = substr(this.SectionArray[n],at("=",this.SectionArray[n])+1)
      if type("cDelimiter") = "C"
          nLen = len(cString)
          nPosition = 1
          nCol = 1
          do while nPosition < nLen .and. nCol <= nCols
              cSubStr = substr(cString, nPosition)
              if nCol < nCols
                  cSubStr = left(cSubStr, at(cDelimiter, cSubStr) - 1)
              endif
              nPosition = nPosition + len(cSubStr) + 1
              this.ValuesArray[n,nCol] = cSubStr
              nCol = nCol + 1
          enddo
      else
          this.ValuesArray[n,1] = cString
      endif
  endfor
  aArrays.add(this.ValuesArray)
  RETURN aArrays

  PROCEDURE CharCount(cChar, cStr)
  local cString, nCnt
  cString = cStr
  nCnt = 0
  do while cChar $ cString
      nCnt = nCnt + 1
      cString = substr( cString, at(cChar, cString)+1 )
  enddo
  RETURN nCnt

ENDCLASS

*-- EoF: ini.prg
